#	START NEW ARIX SCCS HEADER
#
#	@(#) M68020.mk: version 25.1 created on 11/27/91 at 15:07:41
#
#	Copyright (c) 1990 by Arix Corporation
#	All Rights Reserved
#
#	@(#)M68020.mk	25.1	11/27/91 Copyright (c) 1990 by Arix Corporation
#
#	END NEW ARIX SCCS HEADER
#

#ident	"@(#)uts/os/M68020:M68020.mk	22.1"

#B=$(BASEDIR)/$(CURDIR)/
B=./

include $(IROOT)/macdefs
include $(SROOT)/uts/$(MACH)/kernflag.inc

FRC =
LIBNAME = $(LIBOS)
CURDIR = uts/os
.PRECIOUS:	$(LIBNAME)

FILES = \
	$(LIBNAME)($(B)buserr.o) \
	$(LIBNAME)($(B)fpp.o) \
	$(LIBNAME)($(B)machdep.o) \
	$(LIBNAME)($(B)tdb.o) \
	$(LIBNAME)($(B)trap.o)

$(LIBNAME):	$(FILES)

all:	$(LIBNAME)

install: all
	# installed as $(LIBNAME)

clean:
	rm -f *.o

clobber: clean
	rm -f $(LIBNAME)

FRC:
	-rm -f $(LIBNAME)
	$(AR) qc $(LIBNAME)

.c.a:
	$(CC) -c $(KERNFLAGS) $(CFLAGS) $<; \
	$(AR) r $@ $*.o
	@rm -f $*.o

.o.a:
	$(AR) r $@ $*.o

$(LIBNAME)($(B)buserr.o):	buserr.c \
	$(INCRT)/sys/allregs.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/fpu.h \
	$(INCRT)/sys/fpusim.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/fstyp.h \
	$(INCRT)/sys/getpages.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/inode.h \
	$(INCRT)/sys/lio.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/mount.h \
	$(INCRT)/sys/own.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/pcb.h \
	$(INCRT)/sys/pfdat.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/psl.h \
	$(INCRT)/sys/reg.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/sbus.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/spm_mem.h \
	$(INCRT)/sys/state.h \
	$(INCRT)/sys/swap.h \
	$(INCRT)/sys/synch.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/tdb.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/upkern.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/var.h \
	$(INCRT)/sys/vmem.h \
	$(FRC)


$(LIBNAME)($(B)fpp.o):	fpp.c \
	$(INCRT)/sys/allregs.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/fpu.h \
	$(INCRT)/sys/fpusim.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/own.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/pcb.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/reg.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/state.h \
	$(INCRT)/sys/synch.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/tdb.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/upkern.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vmem.h \
	$(FRC)

$(LIBNAME)($(B)machdep.o):	machdep.c \
	$(INCRT)/sys/allregs.h \
	$(INCRT)/sys/asm_link.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/clock.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/fpu.h \
	$(INCRT)/sys/fpusim.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/ipc.h \
	$(INCRT)/sys/kmem.h \
	$(INCRT)/sys/lio.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/own.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/pcb.h \
	$(INCRT)/sys/pfdat.h \
	$(INCRT)/sys/pm_iomap.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/psl.h \
	$(INCRT)/sys/reg.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/sbus.h \
	$(INCRT)/sys/sbus_spm.h \
	$(INCRT)/sys/shm.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/spm_mem.h \
	$(INCRT)/sys/state.h \
	$(INCRT)/sys/synch.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/tdb.h \
	$(INCRT)/sys/trap.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/upkern.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/var.h \
	$(INCRT)/sys/vmem.h \
	$(FRC)


$(LIBNAME)($(B)tdb.o):	tdb.c \
	$(INCRT)/sys/allregs.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/fpu.h \
	$(INCRT)/sys/fpusim.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/lio.h \
	$(INCRT)/sys/own.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/pcb.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/psl.h \
	$(INCRT)/sys/reg.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/state.h \
	$(INCRT)/sys/synch.h \
	$(INCRT)/sys/tdb.h \
	$(INCRT)/sys/trap.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/upkern.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vmem.h \
	$(FRC)


$(LIBNAME)($(B)trap.o):	trap.c \
	$(INCRT)/sys/allregs.h \
	$(INCRT)/sys/cmn_err.h \
	$(INCRT)/sys/debug.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/fpu.h \
	$(INCRT)/sys/fpusim.h \
	$(INCRT)/sys/fs/s5dir.h \
	$(INCRT)/sys/fs/s5param.h \
	$(INCRT)/sys/icb.h \
	$(INCRT)/sys/immu.h \
	$(INCRT)/sys/lio.h \
	$(INCRT)/sys/own.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/pcb.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/psl.h \
	$(INCRT)/sys/pwrf.h \
	$(INCRT)/sys/reg.h \
	$(INCRT)/sys/region.h \
	$(INCRT)/sys/rtb.h \
	$(INCRT)/sys/signal.h \
	$(INCRT)/sys/spl.h \
	$(INCRT)/sys/state.h \
	$(INCRT)/sys/synch.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/sysmacros.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/tdb.h \
	$(INCRT)/sys/trap.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/upkern.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/var.h \
	$(INCRT)/sys/vmem.h \
	$(FRC)


