/*	START NEW ARIX SCCS HEADER			*/
/*							*/
/*	@(#) sysent.c: version 25.1 created on 11/27/91 at 15:12:56	*/
/*							*/
/*	Copyright (c) 1990 by Arix Corporation		*/
/*	All Rights Reserved				*/
/*							*/
#ident	"@(#)sysent.c	25.1	11/27/91 Copyright (c) 1990 by Arix Corporation"
/*							*/
/*	END NEW ARIX SCCS HEADER			*/
/*							*/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#include "sys/param.h"
#include "sys/types.h"
#include "sys/systm.h"
#include "sys/conf.h"

/*
 * This table is the switch used to transfer
 * to the appropriate routine for processing a system call.
 * Each row contains the number of arguments expected,
 * a switch that tells systrap() in trap.c whether a setjmp() is not necessary,
 * and a pointer to the routine.
 */

int	alarm();
int	chdir();
int	chmod();
int	chown();
int	chroot();
int	close();
int	creat();
int	dup();
int	exec();
int	exece();
int	fcntl();
int	fork();
int	fpathconf();
int	fstat();
int	getgid();
int	getgroups();
int	getitimer();
int	getpid();
int	getrlimit();
int	getuid();
int	gtime();
int	gtty();
int	ioctl();
int	kill();
int	link();
int	lock();
int	locking();	/* file locking hook -- Sept 1980, John Bass */
int	mkfifo();
int	mknod();
int	msgsys();
int	nice();
int	nosys();
int	nullsys();
int	open();
int	pathconf();
int	pause();
int	pipe();
int	profil();
int	ptrace();
int	read();
int	rename();
int	rexit();
int	saccess();
int	sbreak();
int	seek();
int	semsys();
int	setgid();
int	setgroups();
int	setitimer();
int	setpgid();
int	setpgrp();
int	setrlimit();
int	setsid();
int	setuid();
int	shmsys();
int	sigaction();
int	sigpending();
int	sigprocmask();
int 	sigsuspend();
int	smount();
int	ssig();
int	stat();
int	stime();
int	stty();
int	sumount();
int	sync();
int	sysarix();
int	sysacct();
int	sysconf();
int	times();
int	ulimit();
int	umask();
int	unlink();
int	utime();
int	utssys();
int	wait();
int	waitpid();
int	write();

int 	advfs();
int	rfstart();
int 	rfstop();
int 	rdebug();
int 	rmount();
int 	rumount();
int	rfsys();
int	unadvfs();
int	rmdir();
int	mkdir();
int	getdents();
int	statfs();
int	fstatfs();
int	sysfs();
int	getmsg();
int	poll();
int	symlink();
int	readlink();
int	putmsg();
int	uadmin();
int	libattach();
int	libdetach();
int	priv();
int	mls();
int	fileref();
int	audit();
int	acl();
int	facl();
int	lstat();
int	lchown();
#ifdef FIPS
int	ftruncate();
int	fsync();
int	fchown();
int	fchmod();
#endif
int	chgperf();
#ifdef FIPS
int	fchgperf();
#endif
#ifdef	PERF
int	chgsched();
#endif	/* PERF */

struct sysent sysent[] =
{
	0, 1, MULTIPROC, nosys,		/*  0 = indir */
	1, 1, UNIPROC, rexit,		/*  1 = exit */
	0, 1, UNIPROC, fork,		/*  2 = fork */
	3, 0, MULTIPROC, read,		/*  3 = read */
	3, 0, MULTIPROC, write,		/*  4 = write */
	3, 0, MULTIPROC, open,		/*  5 = open */
	1, 0, MULTIPROC, close,		/*  6 = close */
	0, 0, UNIPROC, wait,		/*  7 = wait */
	2, 0, MULTIPROC, creat,		/*  8 = creat */
	2, 1, MULTIPROC, link,		/*  9 = link */
	1, 1, MULTIPROC, unlink,	/* 10 = unlink */
	2, 1, MULTIPROC, exec,		/* 11 = exec */
	1, 1, MULTIPROC, chdir,		/* 12 = chdir */
	0, 1, MULTIPROC, gtime,		/* 13 = time */
	3, 1, MULTIPROC, mknod,		/* 14 = mknod */
	2, 1, MULTIPROC, chmod,		/* 15 = chmod */
	3, 1, MULTIPROC, chown,		/* 16 = chown; now 3 args */
	1, 1, MULTIPROC, sbreak,	/* 17 = break */
	2, 1, MULTIPROC, stat,		/* 18 = stat */
	3, 1, MULTIPROC, seek,		/* 19 = seek */
	0, 1, MULTIPROC, getpid,	/* 20 = getpid */
	6, 1, UNIPROC, smount,		/* 21 = mount */
	1, 1, UNIPROC, sumount,		/* 22 = umount */
	1, 1, MULTIPROC, setuid,	/* 23 = setuid */
	0, 1, MULTIPROC, getuid,	/* 24 = getuid */
	1, 1, UNIPROC, stime,		/* 25 = stime */
	4, 1, UNIPROC, ptrace,		/* 26 = ptrace */
	1, 1, MULTIPROC, alarm,		/* 27 = alarm */
	2, 1, MULTIPROC, fstat,		/* 28 = fstat */
	0, 0, MULTIPROC, pause,		/* 29 = pause */
	2, 1, MULTIPROC, utime,		/* 30 = utime */
	2, 0, UNIPROC, stty,		/* 31 = stty */
	2, 0, UNIPROC, gtty,		/* 32 = gtty */
	2, 1, MULTIPROC, saccess,	/* 33 = access */
	1, 1, MULTIPROC, nice,		/* 34 = nice */
	4, 1, MULTIPROC, statfs,	/* 35 = statfs */
	0, 0, UNIPROC, sync,		/* 36 = sync */
	2, 1, UNIPROC, kill,		/* 37 = kill */
	4, 1, MULTIPROC, fstatfs,	/* 38 = fstatfs */
	1, 1, MULTIPROC, setpgrp,	/* 39 = setpgrp */
	0, 1, MULTIPROC, nosys,		/* 40 = tell - obsolete */
	1, 1, MULTIPROC, dup,		/* 41 = dup */
	0, 0, MULTIPROC, pipe,		/* 42 = pipe */
	1, 1, MULTIPROC, times,		/* 43 = times */
	4, 1, MULTIPROC, profil,	/* 44 = prof */
	1, 1, UNIPROC, lock,		/* 45 = proc lock */
	1, 1, MULTIPROC, setgid,	/* 46 = setgid */
	0, 1, MULTIPROC, getgid,	/* 47 = getgid */
	2, 0, MULTIPROC, ssig,		/* 48 = sig */
	6, 0, UNIPROC, msgsys,		/* 49 = IPC message */
	6, 1, UNIPROC, sysarix,		/* 50 = machine specific functions */
	1, 1, UNIPROC, sysacct,		/* 51 = turn acct off/on */
	4, 0, UNIPROC, shmsys,		/* 52 = shared memory */
	5, 0, MULTIPROC, semsys,	/* 53 = IPC semaphores */
	3, 0, MULTIPROC, ioctl,		/* 54 = ioctl */
	3, 0, UNIPROC, uadmin,		/* 55 = uadmin */
	0, 1, MULTIPROC, nosys,		/* 56 = reserved for exch */
	3, 1, UNIPROC, utssys,		/* 57 = utssys */
	0, 1, MULTIPROC, nosys,		/* 58 = reserved for USG */
	3, 1, MULTIPROC, exece,		/* 59 = exece */
	1, 1, MULTIPROC, umask,		/* 60 = umask */
	1, 1, MULTIPROC, chroot,	/* 61 = chroot */
	3, 0, MULTIPROC, fcntl,		/* 62 = fcntl */
	2, 1, MULTIPROC, ulimit,	/* 63 = ulimit */

/* The following 6 entries were reserved by ATT for Safari 4 */
	3, 0, MULTIPROC, locking,	/* 64 = locking */
	0, 1, MULTIPROC, nosys,		/* 65 */
	0, 1, MULTIPROC, nosys,		/* 66 */
	0, 1, MULTIPROC, nosys,		/* 67 */
	0, 1, MULTIPROC, nosys,		/* 68 */
	0, 1, MULTIPROC, nosys,		/* 69 */

/*
 * This table is the switch used to transfer
 * to the appropriate routine for processing a vmunix special system call.
 * Each row contains the number of arguments expected
 * and a pointer to the routine.
 */

	4, 1, UNIPROC, advfs,		/* 70 = advfs */
	1, 1, UNIPROC, unadvfs,		/* 71 = unadvfs */
	4, 1, UNIPROC, rmount,		/* 72 = rmount */
	1, 1, UNIPROC, rumount,		/* 73 = rumount */
	5, 0, UNIPROC, rfstart,		/* 74 = rfstart */
	0, 1, MULTIPROC, nosys,		/* 75 = not used */
	1, 0, UNIPROC, rdebug,		/* 76 = rdebug */
	0, 1, UNIPROC, rfstop,		/* 77 = rfstop */
	6, 1, UNIPROC, rfsys,		/* 78 = rfsys */
	1, 1, MULTIPROC, rmdir,		/* 79 = rmdir */
	2, 1, MULTIPROC, mkdir,		/* 80 = mkdir */
	4, 1, UNIPROC, getdents,	/* 81 = getdents */
	3, 1, UNIPROC, libattach,	/* 82 = libattach */
	1, 1, UNIPROC, libdetach,	/* 83 = libdetach */
	3, 1, UNIPROC, sysfs,		/* 84 = sysfs */
	4, 0, UNIPROC, getmsg,		/* 85 = getmsg */
	4, 0, UNIPROC, putmsg,		/* 86 = putmsg */
	3, 0, UNIPROC, poll,		/* 87 = poll */
	2, 1, MULTIPROC, lstat,		/* 88 = lstat */
	2, 0, MULTIPROC, symlink,	/* 89 = symlink */
	3, 0, MULTIPROC, readlink,	/* 90 = readlink */
	2, 1, UNIPROC, setgroups,	/* 91 = setgroups */
	2, 1, UNIPROC, getgroups,	/* 92 = getgroups */
#ifdef FIPS
	2, 1, MULTIPROC, fchmod,	/* 93 = fchmod */
	3, 1, MULTIPROC, fchown,	/* 94 = fchown */
#else
	0, 1, MULTIPROC, nosys,		/* 93 = not used */
	0, 1, MULTIPROC, nosys,		/* 94 = not used */
#endif
	3, 1, UNIPROC, sigprocmask,	/* 95 = sigprocmask */
	1, 0, UNIPROC, sigsuspend,	/* 96 = sigsuspend */
	2, 1, MULTIPROC, nosys,		/* 97 = sigaltstack  */
	3, 1, UNIPROC, sigaction,	/* 98 = sigaction */
	2, 1, UNIPROC, sigpending,	/* 99 = sigpending */
	0, 1, MULTIPROC, nosys,		/* 100 = setcontext */
	0, 1, MULTIPROC, nosys,		/* 101 = evsys */
	0, 1, MULTIPROC, nosys,		/* 102 = evtrapret */
	0, 1, MULTIPROC, nosys,		/* 103 = statvfs */
	0, 1, MULTIPROC, nosys,		/* 104 = fstatvfs */
	0, 1, MULTIPROC, nosys,		/* 105 = reserved */
	0, 1, MULTIPROC, nosys,	   	/* 106 = nfssys */
	0, 1, MULTIPROC, nosys,		/* 107 = waitset */
	0, 1, MULTIPROC, nosys,		/* 108 = sigsendset */
	0, 1, MULTIPROC, nosys,		/* 109 = hrtsys */
	0, 1, MULTIPROC, nosys,		/* 110 = acancel */
	0, 1, MULTIPROC, nosys,		/* 111 = async */
	0, 1, MULTIPROC, nosys,		/* 112 = priocntlsys */
	2, 0, UNIPROC,   pathconf,	/* 113 = pathconf */
	0, 1, MULTIPROC, nosys,		/* 114 = mincore */
	0, 1, MULTIPROC, nosys,		/* 115 = mmap */
	0, 1, MULTIPROC, nosys,		/* 116 = mprotect */
	0, 1, MULTIPROC, nosys,		/* 117 = munmap */
	2, 0, UNIPROC,   fpathconf,	/* 118 = fpathconf */
	0, 1, MULTIPROC, nosys,		/* 119 = vfork */
	0, 1, MULTIPROC,nosys,		/* 120 = fchdir */
	0, 1, MULTIPROC, nosys,		/* 121 = readv */
	0, 1, MULTIPROC, nosys,		/* 122 = writev */
	0, 1, MULTIPROC, nosys,		/* 123 = xstat */
	0, 1, MULTIPROC, nosys,		/* 124 = lxstat */
	0, 1, MULTIPROC, nosys,		/* 125 = fxstat */
	0, 1, MULTIPROC, nosys,		/* 126 = xmknod */
	0, 1, MULTIPROC, nosys,		/* 127 = clocal */
	2, 1, MULTIPROC, setrlimit,	/* 128 = setrlimit */
	2, 1, MULTIPROC, getrlimit,	/* 129 = getrlimit */
	3, 1, MULTIPROC, lchown,	/* 130 = lchown */
	0, 1, MULTIPROC, nosys,		/* 131 = memcntl */
	0, 1, MULTIPROC, nosys,		/* 132 = getpmsg */
	0, 1, MULTIPROC, nosys,		/* 133 = putpmsg */
	2, 1, UNIPROC,   rename,	/* 134 = rename */
	0, 1, MULTIPROC, nosys,		/* 135 = nuname */
	0, 1, MULTIPROC, nosys,		/* 136 = setegid */
	1, 1, UNIPROC,   sysconf,	/* 137 = sysconfig */
	0, 1, MULTIPROC, nosys,		/* 138 = adjtime */
	0, 1, MULTIPROC, nosys,		/* 139 = systeminfo */
	0, 1, MULTIPROC, nosys,		/* 140 = reserved */
	0, 1, MULTIPROC, nosys,		/* 141 = seteuid */
	/* stop */
	3, 1, MULTIPROC, priv,		/* 142 = getpriv */
	3, 1, MULTIPROC, mls,  		/* 143 = mls entry point */
	1, 1, MULTIPROC, fileref,	/* 144 = tp reference count */
	3, 1, MULTIPROC, audit, 	/* 145 = security audit */
	4, 1, UNIPROC, acl,		/* 146 = acl */
	4, 1, UNIPROC, facl,		/* 147 = facl */
	3, 1, MULTIPROC, setitimer,	/* 148 = setitimer (BSD) */
	2, 1, MULTIPROC, getitimer,	/* 149 = getitimer (BSD) */
#ifdef FIPS
	1, 1, MULTIPROC, fsync,		/* 150 = fsync */
	2, 1, MULTIPROC, ftruncate,	/* 151 = ftruncate */
#else
	0, 1, MULTIPROC, nosys,		/* 150 = not used */
	0, 1, MULTIPROC, nosys,		/* 151 = not used */
#endif
	3, 0, UNIPROC, waitpid,		/* 152 = waitpid	*/
	2, 0, UNIPROC, setpgid,		/* 153 = setpgid	*/
	0, 1, UNIPROC, setsid,		/* 154 = setsid	*/
	0, 1, MULTIPROC, nosys,    	/* 155 = unused    */
	2, 0, UNIPROC, mkfifo,		/* 156 = mkfifo */
	5, 1, UNIPROC, chgperf,		/* 157 = chgperf */
#ifdef FIPS
	5, 1, UNIPROC, fchgperf,	/* 158 = fchgperf */
#else
	0, 1, UNIPROC, nosys,		/* 158 = not used */
#endif
#ifdef	PERF
	3, 1, UNIPROC, chgsched,	/* 159 = chgsched */
#else	/* PERF */
	0, 1, MULTIPROC, nosys,		/* 159 = not used */
#endif	/* PERF */
};

int	num_sysent = sizeof(sysent) / sizeof(sysent[0]);
