#ifndef SYS_FCNTL_H
#define SYS_FCNTL_H

/*	START NEW ARIX SCCS HEADER			*/
/*							*/
/*	@(#) fcntl.h: version 25.1 created on 11/27/91 at 15:16:38	*/
/*							*/
/*	Copyright (c) 1990 by Arix Corporation		*/
/*	All Rights Reserved				*/
/*							*/
#ident	"@(#)fcntl.h	25.1	11/27/91 Copyright (c) 1990 by Arix Corporation"
/*							*/
/*	END NEW ARIX SCCS HEADER			*/
/*							*/

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	ATT #ident	"kern-port:sys/fcntl.h	10.3"		*/

#include	<sys/types.h>

/* Flag values accessible to open(2) and fcntl(2) */
/*  (The first three can only be set by open) */
#define	O_RDONLY 0
#define	O_WRONLY 1
#define	O_RDWR	 2
#define	O_NDELAY 04	/* Non-blocking I/O */
#define	O_APPEND 010	/* append (writes guaranteed at the end) */
#define O_SYNC	 020	/* synchronous write option */

#ifdef	_POSIX_SOURCE 
#define O_NONBLOCK 04  /* No delay */
#endif

/* Flag values accessible only to open(2) */
#define	O_CREAT	00400	/* open with file create (uses third open arg)*/
#define	O_TRUNC	01000	/* open with truncation */
#define	O_EXCL	02000	/* exclusive open */

#ifdef	_POSIX_SOURCE  
#define O_NOCTTY 04000  /* Don't assign a controlling terminal */
#endif

/* fcntl(2) requests */
#define	F_DUPFD		0	/* Duplicate fildes */
#define	F_GETFD		1	/* Get fildes flags */
#define	F_SETFD		2	/* Set fildes flags */
#define	F_GETFL		3	/* Get file flags */
#define	F_SETFL		4	/* Set file flags */
#define	F_GETLK		5	/* Get file lock */
#define	F_SETLK		6	/* Set file lock */
#define	F_SETLKW	7	/* Set file lock and wait */
#define F_CHKFL		8	/* Check legality of file flag changes */
#define F_ALLOCSP	10	/* reserved */
#define F_FREESP	11	/* reserved */

#ifndef	_POSIX_SOURCE

/* file segment locking set data type - information passed to system by user */
struct flock {
	short	l_type;
	short	l_whence;
	long	l_start;
	long	l_len;		/* len = 0 means until end of file */
        short   l_sysid;
        short   l_pid;
};

#else

/* file segment locking set data type - information passed to system by user */
/* POSIX 1003.1 requires off_t & pid_t in this structure, mr */
struct flock {
	short	l_type;
	short	l_whence;
	off_t	l_start;
	off_t	l_len;		/* len = 0 means until end of file */
        short   l_sysid;
        pid_t   l_pid;
};
#endif	/* _POSIX_SOURCE */

/* For Posix. Mask for use with file access modes.  Taken from file.h */
#define	O_ACCMODE	0x03	/* Mask for file access modes */
				/* O_WRONLY, O_RDONLY, & O_RDWR */

#ifdef _POSIX_SOURCE
#define FD_CLOEXEC 0x1		/* close the fds on exec */
#endif

/* file segment locking types */
	/* Read lock */
#define	F_RDLCK	01
	/* Write lock */
#define	F_WRLCK	02
	/* Remove lock(s) */
#define	F_UNLCK	03

#endif /* SYS_FCNTL_H */
