/*	START NEW ARIX SCCS HEADER			*/
/*							*/
/*	@(#) commands.h: version 25.1 created on 11/27/91 at 15:41:38	*/
/*							*/
/*	Copyright (c) 1990 by Arix Corporation		*/
/*	All Rights Reserved				*/
/*							*/
#ident	"@(#)commands.h	25.1	11/27/91 Copyright (c) 1990 by Arix Corporation"
/*							*/
/*	END NEW ARIX SCCS HEADER			*/
/*							*/

#ifndef COMMANDS_H
#define	COMMANDS_H

/* GROUP 0 AND GROUP 1 COMMANDS ARE TO BE PLACED IN THE COMMAND BLOCK */

		/* GROUP 0 COMMANDS */

#define UNIT_READY 	0x0
#define REZERO		0x1
#define REQ_SENSE	0x3
#define FORMAT_DISK	0x4
#define REASSIGN_BLKS   0x7
#define SEEK		0xb
#define INQUIRY		0x12
#define MODE_SELECT	0x15
#define MODE_SENSE	0x1a
#define START_UNIT	0x1b
#define RECEIVE_DIAG	0x1c
#define SEND_DIAGNOSTIC 0x1d


		/* GROUP 1 COMMANDS */

#define READ_CAPACITY   0x25
#define READ_EXTENDED   0x28
#define WRITE_EXTENDED	0x2A
#define SEEK_EXTENDED   0x2b
#define VERIFY		0x2f
#define READ_DEFECTS	0x37
#define WRITE_BUFFER	0x3b
#define READ_BUFFER	0x3c

/* The following commands are written to the scsi chip command register */

/* Disconnected state commands */

#define RECONNECT_SEQ 	0x40
#define RECONNECT_SEQ_D 0xc0
#define SEL_NO_ATN	0x41
#define SEL_NO_ATN_D	0xc1
#define SEL_ATN		0x42
#define SEL_ATN_D	0xc2
#define SEL_ATN_STOP	0x43
#define SEL_ATN_STOP_D  0xc3
#define ENAB_SEL_RESEL  0x44
#define ENAB_SEL_RESEL_D 0xc4
#define DIS_SEL_RESEL	0x45
#define DIS_SEL_RSEL_D	0xc5

/* Target Commands */

#define SEND_MESSAGE	0x20
#define SEND_MESSAGE_D	0xa0
#define SEND_STATUS	0x21
#define SEND_STATUS_D	0xa1
#define SEND_DATA	0x22
#define SEND_DATA_D	0xa2
#define DISCONNECT_SEQ	0x23
#define DISCONNECT_SEQ_D 0xa3
#define TERMINATE	0x24
#define TERMINATE_D	0xa4
#define TGT_CMD_CMPLT	0x25
#define TGT_CMD_CMPLT_D 0xa5
#define DISCONNECT_CMD	0x27
#define DISCONNECT_CMD_D 0xa7
#define REC_MESSAGE	0x28
#define REC_MESSAGE_D	0xa8
#define REC_COMMAND	0x29
#define REC_COMMAND_D	0xa9
#define REC_DATA	0x2a
#define REC_DATA_D	0xaa
#define REC_CMD_SEQ	0x2b
#define REC_CMD_SEQ_D	0xab

/* Initiator Commands */

#define XFER_INFO	0x10
#define XFER_INFO_D	0x90
#define I_CMD_CMPLT	0x11
#define I_CMD_CMPLT_D	0x91
#define MSG_ACCEPTED	0x12
#define MSG_ACCEPTED_D	0x92
#define XFER_PAD	0x18
#define XFER_PAD_D	0x98
#define SET_ATN		0x1a
#define SET_ATN_D	0x9a

/* Miscellaneous Commands */
#define NOP		0x00
#define NOP_D		0x80
#define FLUSH_FIFO	0x1
#define FLUSH_FIFO_D	0x81
#define RESET_CHIP	0x2
#define RESET_CHIP_D	0x82
#define RESET_BUS	0x3
#define RESET_BUS_D	0x83

#define SET_TRANSFER	0xfe

/* amount of data to be transferred by various commands */
#define INQUIRY_DATA_LENGTH 	0x24
#define SENSE_DATA_LENGTH	0x12
#define EXTENDED_MSG_LENGTH	4

#define SCSICMD 0x25

#endif /* COMMANDS_H */
