/*	START NEW ARIX SCCS HEADER			*/
/*							*/
/*	@(#) chcpu.c: version 25.1 created on 12/2/91 at 13:56:53	*/
/*							*/
/*	Copyright (c) 1990 by Arix Corporation		*/
/*	All Rights Reserved				*/
/*							*/
#ident	"@(#)chcpu.c	25.1	12/2/91 Copyright (c) 1990 by Arix Corporation"
/*							*/
/*	END NEW ARIX SCCS HEADER			*/
/*							*/
#include	"chperf.h"

docpuclamp(argc,argv)
register int	argc;
register char	*argv[];
{
	if (argc < 2)
		return (usagecpuclamp(cname));
	if ((argv[1][0] == '-') && (argv[1][1] == 'h'))
		exit (usage(cname));
	if ((argv[1][0] == '-') && (argv[1][1] == '?'))
		exit (usage(cname));
	if ((argv[1][0] == '-') && (argv[1][1] == 'd')) {
		argc--;
		argv++;
		return (sysperfdebug(argc,argv));
	}
	if ((argv[1][0] == '-') && (argv[1][1] == 'c')) {
		argc--;
		argv++;
		return (syscpucopy(argc,argv));
	}
	if ((argv[1][0] == '-') && (argv[1][1] == 's')) {
		argc--;
		argv++;
		return (syscpustat(argc,argv));
	}
	if ((argv[1][0] == '-') && (argv[1][1] == 'm')) {
		argc--;
		argv++;
		return (sysmaxcpuclamp(argc,argv));
	}
	if ((argv[1][0] == '-') && (argv[1][1] == 'g')) {
		argc--;
		argv++;
		return (sysglobcpuclamp(argc,argv));
	}
	doleader = 0;
	if ((argv[1][0] == '-') && (argv[1][1] == 'l')) {
		argc--;
		argv++;
		doleader++;
	}
	if ((argv[1][0] == '-') && (argv[1][1] == 'f')) {
		if (argv[1][2] == '\0') {
			if (argc > 2) {
				fname = argv[2];
				argc--;
				argv++;
			} else
				return (usagecpuclamp(cname));
		} else	{
			fname = &argv[1][2];
		}
		argc--;
		argv++;
		if (doleader)
			return (fnamecpuflags(fname,argc,argv));
		else
			return (fnamecpuclamp(fname,argc,argv));
	}
	if (doleader)
		return (pidcpuflags(argc,argv));
	else
		return (pidcpuclamp(argc,argv));
}

syscpustat(argc,argv)
register int	argc;
register char	*argv[];
{
register pid_t	pid;

	pid = -1;
	if (argc > 1) {
		pid = (pid_t) atoi(argv[1]);
		argc--;
		argv++;
	}
	if (getcpustat(pid,&newval,&oldval) < 0) {
		if (pid < 0) {
			fprintf(stderr,
				"%s: get system global cpu clamp stats: ",
				cname);
		} else	{
			fprintf(stderr,
				"%s: get cpu clamp stats for pid %d: ",
				cname,((pid == 0) ? getpid() : pid));
		}
		perror("getcpustat");
		return (-errno);
	}
	if (argc < 2) {
		if (pid < 0) {
			fprintf(stderr,
			"system global cpu clamp stats: cnt=%d ovfl=%d\n",
				oldval,newval);
		} else	{
			fprintf(stderr,
			"cpu clamp stats for pid %d: cnt=%d ovfl=%d\n",
				(pid == 0) ? getpid() : pid,oldval,newval);
		}
		return (0);
	}
	oval = atoi(argv[1]);
	argc--;
	argv++;
	if (setcpustat(pid,0,&oval) < 0) {
		if (pid < 0) {
			fprintf(stderr,
			"%s: set system global cpu clamp stat cnt to %d: ",
				cname,oval);
		} else	{
			fprintf(stderr,
			"%s: set cpu clamp stat cnt for pid %d to %d: ",
				cname,((pid == 0) ? getpid() : pid),oval);
		}
		perror("setcpustat cnt");
		return (-errno);
	}
	if (pid < 0) {
		fprintf(stderr,
		"change system global cpu clamp stat cnt from %d to %d\n",
			oldval,oval);
	} else	{
		fprintf(stderr,
		"change cpu clamp stat cnt for pid %d from %d to %d\n",
			(pid == 0) ? getpid() : pid,oldval,oval);
	}
	if (argc < 2)
		return (0);
	nval = atoi(argv[1]);
	if (setcpustat(pid,&nval,0) < 0) {
		if (pid < 0) {
			fprintf(stderr,
			"%s: set system global cpu clamp stat ovfl to %d: ",
				cname,nval);
		} else	{
			fprintf(stderr,
			"%s: set cpu clamp stat ovfl for pid %d to %d: ",
				cname,((pid == 0) ? getpid() : pid),nval);
		}
		perror("setcpustat ovfl");
		return (-errno);
	}
	if (pid < 0) {
		fprintf(stderr,
		"change system global cpu clamp stat ovfl from %d to %d\n",
			newval,nval);
	} else	{
		fprintf(stderr,
		"change cpu clamp stat ovfl for pid %d from %d to %d\n",
			(pid == 0) ? getpid() : pid,newval,nval);
	}
	return (0);
}

syscpucopy(argc,argv)
register int	argc;
register char	*argv[];
{
	if (getcpucopy(&oldval) < 0) {
		fprintf(stderr,"%s: get old system cpu clamp copy flag: ",
			cname);
		perror("getcpucopy");
		return (-errno);
	}
	if (argc < 2) {
		fprintf(stderr,"current system cpu clamp copy flag is %d\n",
			oldval);
		return (oldval);
	}
	newval = atoi(argv[1]);
	if (setcpucopy(&newval,&oldval) < 0) {
		fprintf(stderr,
			"%s: set new system cpu clamp copy flag to %d: ",
			cname,newval);
		perror("setcpucopy");
		return (-errno);
	}
	fprintf(stderr,"change system cpu clamp copy flag from %d to %d\n",
		oldval,newval);
	return (newval);
}

sysmaxcpuclamp(argc,argv)
register int	argc;
register char	*argv[];
{
	if (getmaxcpuclamp(&oldval) < 0) {
		fprintf(stderr,"%s: get old system maximum cpu clamp: ",cname);
		perror("getmaxcpuclamp");
		return (-errno);
	}
	if (argc < 2) {
		fprintf(stderr,"current system maximum cpu clamp is %d\n",
			oldval);
		return (oldval);
	}
	newval = atoi(argv[1]);
	if (setmaxcpuclamp(&newval,&oldval) < 0) {
		fprintf(stderr,"%s: set new system maximum cpu clamp to %d: ",
			cname,newval);
		perror("setmaxcpuclamp");
		return (-errno);
	}
	fprintf(stderr,"change system maximum cpu clamp from %d to %d\n",
		oldval,newval);
	return (newval);
}

sysglobcpuclamp(argc,argv)
register int	argc;
register char	*argv[];
{
	if (getglobcpuclamp(&oldval) < 0) {
		fprintf(stderr,"%s: get old system global cpu clamp: ",cname);
		perror("getglobcpuclamp");
		return (-errno);
	}
	if (argc < 2) {
		fprintf(stderr,"current system global cpu clamp is %d\n",
			oldval);
		return (oldval);
	}
	newval = atoi(argv[1]);
	if (setglobcpuclamp(&newval,&oldval) < 0) {
		fprintf(stderr,"%s: set new system global cpu clamp to %d: ",
			cname,newval);
		perror("setglobcpuclamp");
		return (-errno);
	}
	fprintf(stderr,"change system global cpu clamp from %d to %d\n",
		oldval,newval);
	return (newval);
}

pidcpuclamp(argc,argv)
register int	argc;
register char	*argv[];
{
register pid_t	pid;

	pid = (pid_t) atoi(argv[1]);
	if (pid < 0)
		pid = 0;
	argc--;
	argv++;
	if (getcpuclamp(pid,&oldval) < 0) {
		fprintf(stderr,"%s: get old cpu clamp of pid=%d: ",cname,pid);
		perror("getcpuclamp");
		return (-errno);
	}
	if (argc < 2) {
		fprintf(stderr,"current cpu clamp of process %d is %d\n",
			((pid <= 0) ? getpid() : pid),oldval);
		return (oldval);
	}
	newval = atoi(argv[1]);
	if (setcpuclamp(pid,&newval,&oldval) < 0) {
		fprintf(stderr,"%s: set new cpu clamp of pid=%d to %d: ",
			cname,pid,newval);
		perror("setcpuclamp");
		return (-errno);
	}
	fprintf(stderr,"change cpu clamp of process %d from %d to %d\n",
		((pid <= 0) ? getpid() : pid),oldval,newval);
	return (newval);
}

fnamecpuclamp(fname,argc,argv)
register char	*fname, *argv[];
register int	argc;
{
	if (getfcpuclamp(fname,&oldval) < 0) {
		fprintf(stderr,"%s: get old cpu clamp of file '%s': ",
			cname,fname);
		perror("getfcpuclamp");
		return (-errno);
	}
	if (argc < 2) {
		fprintf(stderr,"current cpu clamp of file '%s' is %d\n",
			fname,oldval);
		return (oldval);
	}
	newval = atoi(argv[1]);
	if (setfcpuclamp(fname,&newval,&oldval) < 0) {
		fprintf(stderr,"%s: set new cpu clamp of file '%s': ",
			cname,fname);
		perror("setfcpuclamp");
		return (-errno);
	}
	fprintf(stderr,"change cpu clamp of file '%s' from %d to %d\n",
		fname,oldval,newval);
	return (newval);
}

pidcpuflags(argc,argv)
register int	argc;
register char	*argv[];
{
register pid_t	pid;

	pid = (pid_t) atoi(argv[1]);
	if (pid < 0)
		pid = 0;
	argc--;
	argv++;
	if (getcpuflags(pid,&oldval) < 0) {
		fprintf(stderr,"%s: get old cpu clamp leader flag of pid=%d: ",cname,pid);
		perror("getcpuflags");
		return (-errno);
	}
	if (argc < 2) {
		fprintf(stderr,"current cpu clamp leader flag of process %d is %d\n",
			((pid <= 0) ? getpid() : pid),oldval);
		return (oldval);
	}
	newval = atoi(argv[1]);
	if (setcpuflags(pid,&newval,&oldval) < 0) {
		fprintf(stderr,"%s: set new cpu clamp leader flag of pid=%d to %d: ",
			cname,pid,newval);
		perror("setcpuflags");
		return (-errno);
	}
	fprintf(stderr,"change cpu clamp leader flag of process %d from %d to %d\n",
		((pid <= 0) ? getpid() : pid),oldval,newval);
	return (newval);
}

fnamecpuflags(fname,argc,argv)
register char	*fname, *argv[];
register int	argc;
{
	if (getfcpuflags(fname,&oldval) < 0) {
		fprintf(stderr,"%s: get old cpu clamp leader flag of file '%s': ",
			cname,fname);
		perror("getfcpuflags");
		return (-errno);
	}
	if (argc < 2) {
		fprintf(stderr,"current cpu clamp leader flag of file '%s' is %d\n",
			fname,oldval);
		return (oldval);
	}
	newval = atoi(argv[1]);
	if (setfcpuflags(fname,&newval,&oldval) < 0) {
		fprintf(stderr,"%s: set new cpu clamp leader flag of file '%s': ",
			cname,fname);
		perror("setfcpuflags");
		return (-errno);
	}
	fprintf(stderr,"change cpu clamp leader flag of file '%s' from %d to %d\n",
		fname,oldval,newval);
	return (newval);
}
