/*	START NEW ARIX SCCS HEADER			*/
/*							*/
/*	@(#) sh.init.c: version 1.3 created on 3/6/90 at 14:37:59	*/
/*							*/
/*	Copyright (c) 1990 by Arix Corporation		*/
/*	All Rights Reserved				*/
/*							*/
#ident	"@(#)sh.init.c	1.3	3/6/90 Copyright (c) 1990 by Arix Corporation"
/*							*/
/*	END NEW ARIX SCCS HEADER			*/
/*							*/
/*
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.  The Berkeley Software License Agreement
 * specifies the terms and conditions for redistribution.
 */

#ifndef lint
static char *sccsid = "@(#)sh.init.c	5.2 (Berkeley) 6/6/85";
#endif

#include "sh.local.h"
#include "sys/signal.h"

/*
 * C shell
 */

extern	int doalias();
extern	int dobg();
extern	int dobreak();
extern	int dochngd();
extern	int docontin();
extern	int dodirs();
extern	int doecho();
extern	int doelse();
extern	int doend();
extern	int doendif();
extern	int doendsw();
extern	int doeval();
extern	int doexit();
extern	int dofg();
extern	int doforeach();
extern	int doglob();
extern	int dogoto();
extern	int dohash();
extern	int dohist();
extern	int doif();
extern	int dojobs();
#ifdef	KILL
extern	int dokill();
#endif	/* KILL */
extern	int dolet();
extern	int dolimit();
extern	int dologin();
extern	int dologout();
#ifdef NEWGRP
extern	int donewgrp();
#endif
extern	int donice();
extern	int donotify();
extern	int donohup();
extern	int doonintr();
extern	int dopopd();
extern	int dopushd();
extern	int dorepeat();
extern	int doset();
extern	int dosetenv();
extern	int dosource();
extern	int dostop();
extern	int dosuspend();
extern	int doswbrk();
extern	int doswitch();
extern	int dotime();
extern	int dounlimit();
extern	int doumask();
extern	int dowait();
extern	int dowhile();
extern	int dozip();
extern	int execash();
extern	int goodbye();
#ifdef VFORK
extern	int hashstat();
#endif
extern	int shift();
/* showall was in the alloc.c provided with csh  - alloc.c 
	has been replaced by the 5.3 library function "malloc" - port */
/*
extern	int showall();
*/
extern	int unalias();
extern	int dounhash();
extern	int unset();
extern	int dounsetenv();

#define	INF	1000

struct	biltins {
	char	*bname;
	int	(*bfunct)();
	short	minargs, maxargs;
} bfunc[] = {
	"@",		dolet,		0,	INF,
	"alias",	doalias,	0,	INF,
/*
	"alloc",	showall,	0,	1,
*/
	"bg",		dobg,		0,	INF,
	"break",	dobreak,	0,	0,
	"breaksw",	doswbrk,	0,	0,
#ifdef IIASA
	"bye",		goodbye,	0,	0,
#endif
	"case",		dozip,		0,	1,
	"cd",		dochngd,	0,	1,
	"chdir",	dochngd,	0,	1,
	"continue",	docontin,	0,	0,
	"default",	dozip,		0,	0,
	"dirs",		dodirs,		0,	1,
	"echo",		doecho,		0,	INF,
	"else",		doelse,		0,	INF,
	"end",		doend,		0,	0,
	"endif",	dozip,		0,	0,
	"endsw",	dozip,		0,	0,
	"eval",		doeval,		0,	INF,
	"exec",		execash,	1,	INF,
	"exit",		doexit,		0,	INF,
	"fg",		dofg,		0,	INF,
	"foreach",	doforeach,	3,	INF,
#ifdef IIASA
	"gd",		dopushd,	0,	1,
#endif
	"glob",		doglob,		0,	INF,
	"goto",		dogoto,		1,	1,
#ifdef VFORK
	"hashstat",	hashstat,	0,	0,
#endif
	"history",	dohist,		0,	2,
	"if",		doif,		1,	INF,
	"jobs",		dojobs,		0,	1,
#ifdef	KILL
	"kill",		dokill,		1,	INF,
#endif	/* KILL */
	"limit",	dolimit,	0,	3,
	"login",	dologin,	0,	1,
	"logout",	dologout,	0,	0,
#ifdef NEWGRP
	"newgrp",	donewgrp,	1,	1,
#endif
	"nice",		donice,		0,	INF,
#ifndef PORT
	"nohup",	donohup,	0,	INF,
#endif
	"notify",	donotify,	0,	INF,
	"onintr",	doonintr,	0,	2,
	"popd",		dopopd,		0,	1,
	"pushd",	dopushd,	0,	1,
#ifdef IIASA
	"rd",		dopopd,		0,	1,
#endif
	"rehash",	dohash,		0,	0,
	"repeat",	dorepeat,	2,	INF,
	"set",		doset,		0,	INF,
	"setenv",	dosetenv,	0,	2,
	"shift",	shift,		0,	1,
	"source",	dosource,	1,	2,
	"stop",		dostop,		1,	INF,
	"suspend",	dosuspend,	0,	0,
	"switch",	doswitch,	1,	INF,
	"time",		dotime,		0,	INF,
	"umask",	doumask,	0,	1,
	"unalias",	unalias,	1,	INF,
	"unhash",	dounhash,	0,	0,
	"unlimit",	dounlimit,	0,	INF,
	"unset",	unset,		1,	INF,
	"unsetenv",	dounsetenv,	1,	INF,
	"wait",		dowait,		0,	0,
	"while",	dowhile,	1,	INF,
};
int nbfunc = sizeof bfunc / sizeof *bfunc;

#define	ZBREAK		0
#define	ZBRKSW		1
#define	ZCASE		2
#define	ZDEFAULT 	3
#define	ZELSE		4
#define	ZEND		5
#define	ZENDIF		6
#define	ZENDSW		7
#define	ZEXIT		8
#define	ZFOREACH	9
#define	ZGOTO		10
#define	ZIF		11
#define	ZLABEL		12
#define	ZLET		13
#define	ZSET		14
#define	ZSWITCH		15
#define	ZTEST		16
#define	ZTHEN		17
#define	ZWHILE		18

struct srch {
	char	*s_name;
	short	s_value;
} srchn[] = {
	"@",		ZLET,
	"break",	ZBREAK,
	"breaksw",	ZBRKSW,
	"case",		ZCASE,
	"default", 	ZDEFAULT,
	"else",		ZELSE,
	"end",		ZEND,
	"endif",	ZENDIF,
	"endsw",	ZENDSW,
	"exit",		ZEXIT,
	"foreach", 	ZFOREACH,
	"goto",		ZGOTO,
	"if",		ZIF,
	"label",	ZLABEL,
	"set",		ZSET,
	"switch",	ZSWITCH,
	"while",	ZWHILE,
};
int nsrchn = sizeof srchn / sizeof *srchn;

struct	mesg {
	char	*iname;
	char	*pname;
} mesg[] = {
/*  0 */	0,	0,
/*  1 */	"HUP",	"Hangup",
/*  2 */	"INT",	"Interrupt",	
/*  3 */	"QUIT",	"Quit",
/*  4 */	"ILL",	"Illegal instruction",
/*  5 */	"TRAP",	"Trace/BPT trap",
/*  6 */	"IOT",	"IOT trap",
/*  7 */	"EMT",	"EMT trap",
/*  8 */	"FPE",	"Floating exception",
/*  9 */	"KILL",	"Killed",
/* 10 */	"BUS",	"Bus error",
/* 11 */	"SEGV",	"Segmentation fault",
/* 12 */	"SYS",	"Bad system call",
/* 13 */	"PIPE",	"Broken pipe",
/* 14 */	"ALRM",	"Alarm clock",
/* 15 */	"TERM",	"Terminated",
/* 16 */	"USR1",	"User signal 1",
/* 17 */	"USR2",	"User signal 2",
/* 18 */	"CHLD",	"child exited",
/* 19 */	"PWR",	"Power fail",
/* 20 */	"WINCH","Window size changed",
/* 21 */	"URG",	"Urgent socket condition",
/* 22 */	"POLL",	"Pollable event occurred",
#ifdef	NOJOBS
/* 23 */	0,	"Stopped (signal)",
/* 24 */	0,	"Stopped",
/* 25 */	0,	"Continue the process",
/* 26 */	0,	"Stopped (tty input)",
/* 27 */	0,	"Stopped (tty output)",
#else	/* NOJOBS */
/* 23 */	"STOP",	"Stopped (signal)",
/* 24 */	"TSTP",	"Stopped",
/* 25 */	"CONT",	"Continue the process",
/* 26 */	"TTIN",	"Stopped (tty input)",
/* 27 */	"TTOU",	"Stopped (tty output)",
#endif	/* NOJOBS */
/* 28 */	"VTALRM",	"Virtual timer expired",
/* 29 */	"PROF",	"Profiling timer expired",
#ifdef	NOJOBS
/* 30 */	"USER1","User defined signal 1",
/* 31 */	"USER2","User defined signal 2",
#else	/* NOJOBS */
/* 30 */	"SAK",	"Security attention key",
/* 31 */	0,	"User defined signal 1",
#endif	/* NOJOBS */
/* 32 */	0,	"Signal 32",
};
