#	START NEW ARIX SCCS HEADER
#
#	@(#) iopmfmt.mk: version 25.1 created on 12/2/91 at 15:49:32
#
#	Copyright (c) 1990 by Arix Corporation
#	All Rights Reserved
#
#	@(#)iopmfmt.mk	25.1	12/2/91 Copyright (c) 1990 by Arix Corporation
#
#	END NEW ARIX SCCS HEADER
#
#	Copyright (c) 1989 ARIX
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ARIX
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#	ATT:#ident	"iopmfmt:/iopmfmt.mk	1.1"

#ident	"@(#)iopmfmt:iopmfmt.mk	25.1"

IROOT =
SROOT =
include $(IROOT)/macdefs

INSDIR		=	$(ROOT)/local/bin
VERPATT = 's/^.define[ 	]*IOPMFMT_VERSION[ 	]*\([0-9]*\)/-VS \1/p'
VERFLAG = `sed -n -e $(VERPATT) $(SRCDIR)/iopmfmt.h`

# There are two versions of iopmfmt, a standalone and a utility version.
# These share the same source code. To ensure that the latest source is
# always used, only one copy is kept, in the standalone directory. 
# The make of the utility iopmfmt creates a local copy of the source,
# compiles it and then deletes it.
# 
# It would be preferable if the stand directory was not hardcoded here, but
# there are no obvious alternatives.

STAND = $(BUILD)/system/stand
SRCDIR = $(STAND)/cmd/iopmfmt
CFLAG	= -I$(SRCDIR) $(CFLAGS)

SRCFILES = \
	ccs_dskcdb.c \
	dev_info.c \
	disktest.c \
	fmt_menu.c \
	format.c \
	reassign.c \
	scsi_ermsg.c \
	slice.c \
	vdr_dskcdb.c

OBFILES = \
	ccs_dskcdb.o \
	dev_info.o \
	disktest.o \
	fmt_menu.o \
	format.o \
	reassign.o \
	scsi_ermsg.o \
	slice.o \
	vdr_dskcdb.o

all:	iopmfmt

install: iopmfmt
	$(INS) iopmfmt $(INSDIR)/iopmfmt
	chmod 550 $(INSDIR)/iopmfmt
	chown bin $(INSDIR)/iopmfmt
	chgrp bin $(INSDIR)/iopmfmt

clean clobber: wipe
	rm -rf iopmfmt greplist tags *.o


iopmfmt : copy $(OBFILES) wipe
	$(CC) $(CFLAG) -o iopmfmt $(OBFILES) $(VERFLAG)

copy :
	@-for i in $(SRCFILES); \
	do \
		echo "cp $(SRCDIR)/$$i $$i"; \
		if [ -s $$i ]; \
		then \
			rm -f $$i; \
		fi ; \
		cp $(SRCDIR)/$$i $$i; \
	done

.c.o:
	$(CC) -c $(CFLAG) $<

wipe :
	rm -f $(SRCFILES)
