/*	START NEW ARIX SCCS HEADER			*/
/*							*/
/*	@(#) passmgmt.h: version 25.1 created on 12/2/91 at 16:45:07	*/
/*							*/
/*	Copyright (c) 1990 by Arix Corporation		*/
/*	All Rights Reserved				*/
/*							*/
#ident	"@(#)passmgmt.h	25.1	12/2/91 Copyright (c) 1990 by Arix Corporation"
/*							*/
/*	END NEW ARIX SCCS HEADER			*/
/*							*/
#ifndef	PASSMGMT_H
#define	PASSMGMT_H

/*
 * Masks for the optn_mask variable for passmgmt processing.
 */
#define UA_MASK_A	0x00000001
#define UA_MASK_F	0x00000002
#define UA_MASK_G	0x00000004
#define UA_MASK_M	0x00000008
#define UA_MASK_P	0x00000010
#define UA_MASK_R	0x00000020
#define UA_MASK_T	0x00000040
#define UA_MASK_a	0x00000080
#define UA_MASK_c	0x00000100
#define UA_MASK_d	0x00000200
#define UA_MASK_f	0x00000400
#define UA_MASK_g	0x00000800
#define UA_MASK_h	0x00001000
#define UA_MASK_k	0x00002000
#define UA_MASK_l	0x00004000
#define UA_MASK_m	0x00008000
#define UA_MASK_o	0x00010000
#define UA_MASK_p	0x00020000
#define UA_MASK_s	0x00040000
#define UA_MASK_u	0x00080000
#define UA_MASK_x	0x00100000
#define UA_MASK_D	0x00200000
#define UA_MASK_I	0x00400000

/*
 * Masks for the optn_mask variable for devmgmt processing.
 */
#define TA_MASK_B	0x00000001
#define TA_MASK_D	0x00000002
#define TA_MASK_G	0x00000004
#define TA_MASK_U	0x00000008
#define TA_MASK_a	0x00000010
#define TA_MASK_b	0x00000020
#define TA_MASK_d	0x00000040
#define TA_MASK_g	0x00000080
#define TA_MASK_i	0x00000100
#define TA_MASK_k	0x00000200
#define TA_MASK_l	0x00000400
#define TA_MASK_m	0x00000800
#define TA_MASK_r	0x00001000
#define TA_MASK_s	0x00002000
#define TA_MASK_u	0x00004000
#define TA_MASK_f	0x00008000
#define TA_MASK_F	0x00010000
#define TA_MASK_I	0x00020000

					/* flags for info_mask */
#define PASS_CHANGED	0x00000001	/* passwd file has been changed */
#define GROUP_CHANGED	0x00000002	/* group file has been changed */
#define UAUTH_CHANGED	0x00000004	/* user auth file has been changed */
#define TAUTH_CHANGED	0x00000008	/* tty auth file has been changed */
#define PASS_FLAG	0x00000010	/* running with password flag */
#define GROUP_FLAG	0x00000020	/* running with group flag */
#define UAUTH_FLAG	0x00000040	/* running with user_auth flag */
#define TAUTH_FLAG	0x00000080	/* running with tty auth flag */
#define PASS_UPDATE	0x00000100	/* modifying passwd file */
#define GROUP_UPDATE	0x00000200	/* modifying group file */
#define UAUTH_UPDATE	0x00000400	/* modifying user auth file */
#define TAUTH_UPDATE	0x00000800	/* modifying tty auth file */
#define LOGNAME_EXIST	0x00001000	/* logname exists */
#define NEED_DEF_UID	0x00002000	/* need default uid */
#define FOUND		0x00004000	/* found the entry in password file */
#define PROFILE_LOADED	0x00008000	/* set after loading profile file */
#define UAUTH_PROFILE	0x00010000	/* set usr_auth defaults from profile */
#define TAUTH_PROFILE	0x00020000	/* set dev_auth defaults from profile */

#define CMT_SIZE	(128+1)	/* Argument sizes + 1 (for '\0') */
#define DIR_SIZE	(256+1)
#define SHL_SIZE	(256+1)
#define ENTRY_LENGTH	512	/* Max length of an /etc/passwd entry */
#define UID_MIN		100	/* Lower bound of default UID */
#define DAY_SECS	(24 * 60 * 60) /* seconds in day */
#define NO_LOCK		-1
#define	TA_USERS_ALL	-2	/* "*" wild card.... */
#define	TA_GROUPS_ALL	-2	/* "*" wild card.... */

/*
 *	The uid_blk structure is used in the search for the default
 *	uid.  Each uid_blk represent a range of uid(s) that are currently
 *	used on the system.
 */
typedef	struct	uid_blk	{
	struct	uid_blk	*link;
	int		low;		/* low bound for this uid block */
	int		high; 		/* high bound for this uid block */
	} ublk_t;

#endif	/* PASSMGMT_H */
