/*	START NEW ARIX SCCS HEADER			*/
/*							*/
/*	@(#) pwd.c: version 25.1 created on 12/2/91 at 18:02:46	*/
/*							*/
/*	Copyright (c) 1990 by Arix Corporation		*/
/*	All Rights Reserved				*/
/*							*/
#ident	"@(#)pwd.c	25.1	12/2/91 Copyright (c) 1990 by Arix Corporation"
/*							*/
/*	END NEW ARIX SCCS HEADER			*/
/*							*/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	AT&T: #ident "sh:pwd.c	1.14"				*/


/* 
*	UNIX shell
 */

#include		"mac.h"
#include	<sys/types.h>
#include	<dirent.h>
#include	<sys/stat.h>

#define	DOT		'.'
#define	NULL	0
#define	SLASH	'/'
#define MAXPWD	512

#define EXCEPT_SYMLINKS	7	/* 7's lucky, which I will be if changes
				 * for symlinks works.
				 */

extern char	longpwd[];

static char cwdname[MAXPWD];
static int 	didpwd = FALSE;

cwd(dir)
	register char *dir;
{
	register char *pcwd;
	register char *pdir;

	/* First remove extra /'s */

	rmslash(dir);

	/* Now remove any .'s */

	pdir = dir;
	if(*dir == SLASH)
		pdir++;
	while(*pdir) 			/* remove /./ by itself */
	{
		if((*pdir==DOT) && (*(pdir+1)==SLASH))
		{
			movstr(pdir+2, pdir);
			continue;
		}
		pdir++;
		while ((*pdir) && (*pdir != SLASH)) 
			pdir++;
		if (*pdir) 
			pdir++;
	}
	/* take care of trailing /. */
	if(*(--pdir)==DOT && pdir > dir && *(--pdir)==SLASH) {
		if(pdir > dir) {
			*pdir = NULL;
		} else {
			*(pdir+1) = NULL;
		}
	
	}
	
	/* Remove extra /'s */

	rmslash(dir);

	/* Now that the dir is canonicalized, process it */

	if(*dir==DOT && *(dir+1)==NULL)
	{
		return;
	}

	if(*dir==SLASH)
	{
		/* Absolute path */

		pcwd = cwdname;
	 	if (pcwd >= &cwdname[MAXPWD])
		{
			didpwd=FALSE;
			return;
		}
		*pcwd++ = *dir++;
		didpwd = EXCEPT_SYMLINKS;
	}
	else
	{
		/* Relative path */

		if (didpwd == FALSE) 
			return;
			
		didpwd = EXCEPT_SYMLINKS;

		pcwd = cwdname + length(cwdname) - 1;
		if(pcwd != cwdname+1)
		{
			*pcwd++ = SLASH;
		}
	}
	while(*dir)
	{
		if(*dir==DOT && 
		   *(dir+1)==DOT &&
		   (*(dir+2)==SLASH || *(dir+2)==NULL))
		{
			/* Parent directory, so backup one */

			if( pcwd > cwdname+2 )
				--pcwd;
			while(*(--pcwd) != SLASH)
				;
			pcwd++;
			dir += 2;
			if(*dir==SLASH)
			{
				dir++;
			}
			continue;
		}
	 	if (pcwd >= &cwdname[MAXPWD])
		{
			didpwd=FALSE;
			return;
		}
		*pcwd++ = *dir++;
		while((*dir) && (*dir != SLASH))
		{  
	 		if (pcwd >= &cwdname[MAXPWD])
			{
				didpwd=FALSE;
				return;
			}
			*pcwd++ = *dir++;
		} 
		if (*dir) 
		{
	 		if (pcwd >= &cwdname[MAXPWD])
			{
			didpwd=FALSE;
			return;
			}
			*pcwd++ = *dir++;
		}
	}
	if (pcwd >= &cwdname[MAXPWD])
	{
		didpwd=FALSE;
		return;
	}
	*pcwd = NULL;

	--pcwd;
	if(pcwd>cwdname && *pcwd==SLASH)
	{
		/* Remove trailing / */

		*pcwd = NULL;
	}
	return;
}

/*
 *	This routine will remove repeated slashes from string.
 */

static
rmslash(string)
	char *string;
{
	register char *pstring;

	pstring = string;
	while(*pstring)
	{
		if(*pstring==SLASH && *(pstring+1)==SLASH)
		{
			/* Remove repeated SLASH's */

			movstr(pstring+1, pstring);
			continue;
		}
		pstring++;
	}

	--pstring;
	if(pstring>string && *pstring==SLASH)
	{
		/* Remove trailing / */

		*pstring = NULL;
	}
	return;
}

/*
 *	Find the current directory the hard way.
 */



static char dotdots[] =
"../../../../../../../../../../../../../../../../../../../../../../../..";

extern char		*movstrn();

static
pwd()
{
	struct stat		cdir;	/* current directory status */
	struct stat		tdir;
	struct stat		pdir;	/* parent directory status */
	DIR			*pdfd;	/* parent directory stream */

	struct dirent	*dir;
	char 			*dot = dotdots + sizeof(dotdots) - 3;
	int				index = sizeof(dotdots) - 2;
	int				cwdindex = MAXPWD - 1;
	int 			i;
	
	cwdname[cwdindex] = 0;
	dotdots[index] = 0;

	if(stat(dot, &pdir) < 0)
	{
		error("pwd: cannot stat .");
	}

	dotdots[index] = '.';

	for(;;)
	{
		cdir = pdir;

		if ((pdfd = opendir(dot)) == 0)
		{
			error("pwd: cannot open ..");
		}

		if(fstat(pdfd->dd_fd, &pdir) < 0)
		{
			(void)closedir(pdfd);
			error("pwd: cannot stat ..");
		}

		if(cdir.st_dev == pdir.st_dev)
		{
			if(cdir.st_ino == pdir.st_ino)
			{
				didpwd = TRUE;
				(void)closedir(pdfd);
				if (cwdindex == (MAXPWD - 1))
					cwdname[--cwdindex] = SLASH;

				movstr(&cwdname[cwdindex], cwdname);
				return;
			}

			do
			{
				if ((dir = readdir(pdfd)) == 0)
				{
					(void)closedir(pdfd);
					error("pwd: read error in ..");
				}
			}
			while (dir->d_ino != cdir.st_ino);
		}
		else
		{
			char name[MAXPWD];
			
			movstr(dot, name);
			i = length(name) - 1;

			name[i++] = '/';

			do
			{
				if ((dir = readdir(pdfd)) == 0)
				{
					(void)closedir(pdfd);
					error("pwd: read error in ..");
				}
				movstr(dir->d_name, &name[i]);
				stat(name, &tdir);
			}		
			while(tdir.st_ino != cdir.st_ino || tdir.st_dev != cdir.st_dev);
		}
		(void)closedir(pdfd);

		for (i = 0;; i++)
			if (dir->d_name[i] == 0)
				break;

		if (i > cwdindex - 1)
				error(longpwd);
		else
		{
			cwdindex -= i;
			movstrn(dir->d_name, &cwdname[cwdindex], i);
			cwdname[--cwdindex] = SLASH;
		}

		dot -= 3;
		if (dot<dotdots) 
			error(longpwd);
	}
}


/* check if there are any symbolic links in pathname */
void
checkforsymlinks()
{
	struct stat	stata;
	struct stat	statb;
	char	 	*cwd_ptr; /* pointer to pathname */
	char 		c;

	if(didpwd == FALSE)
		return;

	cwd_ptr = cwdname + 1;

	/* if symlinks processing not done.... */
	if(didpwd == EXCEPT_SYMLINKS) {

		/* while path compnents to process... */
		while (*cwd_ptr)
		{
			/* get a path component.... */
			while((c = *cwd_ptr++) != SLASH && c != '\0')
				;
			*--cwd_ptr = '\0'; /* substitute a delimiter */

			/* ...stat it, if its a symbolic link set
			 * didpwd to false, this will force reevaluation
			 * of the current working directory.
			 */
			if (lstat((char *)cwdname, &stata) == -1 ||
				(stata.st_mode & S_IFMT) == S_IFLNK) {

				didpwd = FALSE; /*force a reevaluation of pwd */

				*cwd_ptr = c; /* put back original character */
				return;
			}
			*cwd_ptr = c; /* put back original character */
			if(c)
				cwd_ptr++;
		}
		didpwd = TRUE;

	} else if (stat((char *)cwdname, &stata) == -1) {
		didpwd = FALSE;
		return;
	}
	 /* check for symbolic links with ".." */
	if (stat(".", &statb) == -1
	    || stata.st_dev != statb.st_dev
	    || stata.st_ino != statb.st_ino)
		didpwd = FALSE;
	return;
}

char *
cwdget()
{
	checkforsymlinks();
	if (didpwd == FALSE) {
		pwd();
		didpwd = TRUE;
	} 
	return (cwdname);
}

/*
 *	Print the current working directory.
 */

cwdprint()
{
	checkforsymlinks();
	if (didpwd == FALSE) {
		pwd();
		didpwd = TRUE;
	}
	prs_buff(cwdname);
	prc_buff(NL);
	return;
}
